<?php


namespace Drupal\custom_elements\Processor;

use Drupal\Core\Field\FieldItemInterface;
use Drupal\custom_elements\CustomElement;
use Drupal\link\Plugin\Field\FieldType\LinkItem;

/**
 * Default processor for link field items.
 */
class LinkItemProcessor implements CustomElementProcessorInterface {

  /**
   * {@inheritdoc}
   */
  public function supports($data, $viewMode) {
    return $data instanceof FieldItemInterface && $data instanceof LinkItem;
  }

  /**
   * {@inheritdoc}
   */
  public function addtoElement($data, CustomElement $element, $viewMode) {
    assert($data instanceof LinkItem);
    $link_item = $data;

    if ($link_item->getFieldDefinition()->getSettings()['title']) {
      // Link title either optional or required.
      $element->setTagPrefix('');
      $element->setTag('a');
      $element->setSlot('default', $link_item->title, 'span');
      $element->setAttribute('href', $link_item->getUrl()->toString());
    }
    else {
      // Link title disabled.
      $element->setAttribute('src', $link_item->getUrl()->toString());
    }
  }

}
